/* hexwrite.c - dumps connection info */
/* Written by Matthew Wronka <wronkm@rpi.edu> */
/* probably clean stuff up later if Mark doesn't */
/* [yeah, right] */

#include <stdlib.h>
#include <stdio.h>
#include <netinet/in.h>
#include <signal.h>
#include <netdb.h>
#include <sys/select.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <string.h>

#define HEX_PERLINE 	16
#define HEX_SPACE 	8

int isPrintable(char c) { return (c>=32 && c<=126)?1:0;}

void newline(const char* const history, int n) { 
	int i=0;

	for(i=n; i<HEX_PERLINE; ++i) {
		if(i%HEX_SPACE==0)
			write(1, "   ", 3);
		write(1, "   ", 3);
	}

	write(1, "   ", 3);

	for(i=0; i<n; ++i) {
		char s[3];
		char c=(isPrintable(history[i])?history[i]:'.') ;
		sprintf(s, "%c", c);
		write(1, s, 1);
	}

	write(1,"\n",1); 
}

void hexwrite(int fd, char* buff, int n)
{
	static int last_fd = 0;
	static int num_writ =0;
	char hex_char[4];
	char history[HEX_PERLINE];

	int i=0;

	if (last_fd!=fd) {
		newline(history, num_writ);
		last_fd = fd;
		num_writ= 0;
		printf("%i:\n", fd);
	}

	for(i=0; i < n; ++i){
		if(num_writ >=HEX_PERLINE) {
			newline(history, num_writ);
			num_writ = 0;
		}

		if(num_writ > 0 && (num_writ % HEX_SPACE == 0)){
			write(1, "   ", 3);
		}

		sprintf(hex_char, " %02x", buff[i]);
		write(1, hex_char, 3);
		history[num_writ++]=buff[i];
	}

}
